/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT2.dat, Mon Sep  3 09:42:10 2012
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000032C (812)
 *     Revision         0x01
 *     Checksum         0x58
 *     OEM ID           "Sony"
 *     OEM Table ID     "VAIO"
 *     OEM Revision     0x20120517 (538051863)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("SSDT2.aml", "SSDT", 1, "Sony", "VAIO", 0x20120517)
{
    External (GPS3)
    External (GL08)
    External (GIV0)
    External (GL00)
    External (GPE3)
    External (FDTP)
    External (PFLV)
    External (\_SB_.PCI0, DeviceObj)
    External (\_SB_.PCI0.LPCB.SNC_.CHHD, MethodObj)    // 1 Arguments

    Scope (\_SB.PCI0)
    {
        Device (AHCI)
        {
            Name (_ADR, 0x001F0002)
            Name (FRZN, Zero)
            Method (FCHK, 2, NotSerialized)
            {
                CreateWordField (Arg0, Zero, W000)
                CreateWordField (Arg0, 0x0100, W128)
                And (FRZN, XOr (Arg1, 0xFF), FRZN)
                If (LEqual (And (W000, 0x8080), Zero))
                {
                    If (LAnd (W128, One))
                    {
                        If (LEqual (And (W128, 0x08), Zero))
                        {
                            Or (FRZN, Arg1, FRZN)
                        }
                    }
                }
            }

            Name (GTF0, Buffer (0x07)
            {
                0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5
            })
            Name (GTF1, Buffer (0x07)
            {
                0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xF5
            })
            Device (PRT0)
            {
                Name (_ADR, 0xFFFF)
                Method (_SDD, 1, NotSerialized)
                {
                    FCHK (Arg0, One)
                    \_SB.PCI0.LPCB.SNC.CHHD (Arg0)
                }

                Method (_GTF, 0, NotSerialized)
                {
                    If (LAnd (FRZN, One))
                    {
                        Return (GTF0)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }

            Device (PRT1)
            {
                Name (_ADR, 0x0001FFFF)
                Method (_SDD, 1, NotSerialized)
                {
                    FCHK (Arg0, 0x02)
                }

                Method (_GTF, 0, NotSerialized)
                {
                    If (LAnd (FRZN, 0x02))
                    {
                        Return (GTF1)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }

            Device (PRT2)
            {
                Name (_ADR, 0x0002FFFF)
                Method (_SDD, 1, NotSerialized)
                {
                    FCHK (Arg0, 0x04)
                }

                Method (_GTF, 0, NotSerialized)
                {
                    If (LAnd (FRZN, 0x04))
                    {
                        Return (GTF0)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }

            Device (PRT3)
            {
                Name (_ADR, 0x0003FFFF)
                Method (_SDD, 1, NotSerialized)
                {
                    FCHK (Arg0, 0x08)
                }

                Method (_GTF, 0, NotSerialized)
                {
                    If (LAnd (FRZN, 0x08))
                    {
                        Return (GTF1)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }

            Device (PRT4)
            {
                Name (_ADR, 0x0004FFFF)
                Method (_SDD, 1, NotSerialized)
                {
                    FCHK (Arg0, 0x10)
                }

                Method (_GTF, 0, NotSerialized)
                {
                    If (LAnd (FRZN, 0x10))
                    {
                        Return (GTF0)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }

                Method (_DSM, 4, Serialized)
                {
                    Name (_T_1, Zero)
                    Name (_T_0, Zero)
                    If (LEqual (Arg0, Buffer (0x10)
                            {
                                /* 0000 */    0x30, 0xEF, 0xFA, 0xBD, 0xBB, 0xAE, 0xDE, 0x11, 
                                /* 0008 */    0x8A, 0x39, 0x08, 0x00, 0x20, 0x0C, 0x9A, 0x66
                            }))
                    {
                        While (One)
                        {
                            Store (ToInteger (Arg2), _T_0)
                            If (LEqual (_T_0, Zero))
                            {
                                While (One)
                                {
                                    Store (ToInteger (Arg1), _T_1)
                                    If (LEqual (_T_1, One))
                                    {
                                        If (LEqual (PFLV, FDTP))
                                        {
                                            Return (Buffer (One)
                                            {
                                                0x00
                                            })
                                        }

                                        Return (Buffer (One)
                                        {
                                            0x0F
                                        })
                                    }
                                    Else
                                    {
                                        Return (Buffer (One)
                                        {
                                            0x00
                                        })
                                    }

                                    Break
                                }
                            }
                            Else
                            {
                                If (LEqual (_T_0, One))
                                {
                                    Return (One)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x02))
                                    {
                                        Store (Zero, GPE3)
                                        If (LEqual (And (GL00, 0x08), 0x08))
                                        {
                                            Or (GIV0, 0x08, GIV0)
                                        }
                                        Else
                                        {
                                            And (GIV0, 0xF7, GIV0)
                                        }

                                        And (GL08, 0xEF, GL08)
                                        Sleep (0xC8)
                                        Store (One, GPS3)
                                        Store (One, GPE3)
                                        Return (One)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x03))
                                        {
                                            Store (Zero, GPE3)
                                            Store (One, GPS3)
                                            Or (GL08, 0x10, GL08)
                                            Return (One)
                                        }
                                        Else
                                        {
                                            Return (Zero)
                                        }
                                    }
                                }
                            }

                            Break
                        }
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            Device (PRT5)
            {
                Name (_ADR, 0x0005FFFF)
                Method (_SDD, 1, NotSerialized)
                {
                    FCHK (Arg0, 0x20)
                }

                Method (_GTF, 0, NotSerialized)
                {
                    If (LAnd (FRZN, 0x20))
                    {
                        Return (GTF1)
                    }
                    Else
                    {
                        Return (Buffer (Zero) {})
                    }
                }
            }
        }
    }
}

